DARN Class Reference

Hardware generated random numbers using DARN instruction. More...

Inheritance diagram for DARN:

## Public Member Functions

| DARN ()
| Construct a DARN generator. More...
virtual void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from RandomNumberGenerator
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual byte | GenerateByte ()
| Generate new random byte and return it. More...
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Detailed Description

Hardware generated random numbers using DARN instruction.

DARN() provides access to Power9's random number generator. The Crypto++ implementation provides conditioned random numbers from the generator as opposed to raw random numbers. According to Power ISA 3.0B manual, a conditioned random number has been processed by hardware to reduce bias. A raw random number is unconditioned noise source output.

According to Power ISA 3.0B manual, the random number generator provided by the `darn` instruction is NIST SP800-90B and SP800-90C compliant to the extent possible given the completeness of the standards at the time the hardware is designed. The random number generator provides a minimum of 0.5 bits of entropy per bit.

Wraps
  darn instruction

See also
  Power ISA Version 3.0B, MaurerRandomnessTest() for random bit generators

Since
  Crypto++ 8.0

Definition at line 52 of file darn.h.

## Constructor & Destructor Documentation

## DARN()

DARN::DARN | ( |  | ) |

Construct a DARN generator.

Exceptions

  DARN_Err | if the random number generator is not available

Definition at line 217 of file darn.cpp.

## Member Function Documentation

## GenerateBlock()

void DARN::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |

virtual

Generate random array of bytes.

Parameters

  output | the byte buffer
  size | the length of the buffer, in bytes

Reimplemented from RandomNumberGenerator.

Definition at line 222 of file darn.cpp.

## DiscardBytes()

void DARN::DiscardBytes | ( | size_t | n | ) |

virtual

Generate and discard n bytes.

Parameters

  n | the number of bytes to generate and discard

the RDSEED generator discards words, not bytes. If n is not a multiple of a machine word, then it is rounded up to that size.

Reimplemented from RandomNumberGenerator.

Definition at line 228 of file darn.cpp.

## IncorporateEntropy()

virtual void DARN::IncorporateEntropy | ( | const byte * | input,
|  | size_t | length
| ) |  |

inline virtual

Update RNG state with additional unpredictable values.

Parameters

  input | unused
  length | unused

The operation is a nop for this generator.

Reimplemented from RandomNumberGenerator.

Definition at line 79 of file darn.h.

## AlgorithmProvider()

std::string DARN::AlgorithmProvider | ( |  | ) | const

inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

Definition at line 85 of file darn.h.

The documentation for this class was generated from the following files:

- darn.h
- darn.cpp